if( luup.version_major==0 and luup.version_minor<870 ) then
	luup.log("L_sPhoneUI needs version 870 instead of version: " .. tostring(luup.version_branch) .. "." .. tostring(luup.version_major) .. "." .. tostring(luup.version_minor),1)
	lug_sPhoneTask = luup.task("Upgrade your software",2,"Smartphone UI",-1)
	return
end

luup.register_handler("lug_sPhoneRequest","sPhone")
luup.register_handler("lug_sPhoneRequest_room","sPhone_room")
luup.register_handler("lug_sPhoneRequest_action","sPhone_action")
luup.register_handler("lug_sPhoneRequest_job","sPhone_job")
luup.register_handler("lug_sPhoneRequest_job_status","sPhone_job_status")
luup.register_handler("lug_sPhoneRequest_camimg","sPhone_camimg")
luup.register_handler("lug_sPhoneRequest_action_js","sPhone_action_js")

luup.log("L_sPhoneUI running version: " .. tostring(luup.version_branch) .. "." .. tostring(luup.version_major) .. "." .. tostring(luup.version_minor) )

html_header = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n' ..
'<html xmlns="http://www.w3.org/1999/xhtml">\n' ..
'<head>\n' ..
'	<title>Vera Mobile</title>\n' ..
'	<meta http-equiv="pragma" content="nocache"/>\n' ..
'	<meta name="viewport" content="width=device-width; initial-scale=1.0; maximum-scale=1.0;"/> ' ..
'	<script src="/cmh/js/mobile.js" language="javascript"></script>\n' ..
'	<link rel="stylesheet" href="/cmh/iphone_file/css/iui.css" type="text/css" />\n' ..
'</head>\n' ..
'<body onLoad="js_prepare_urls();">\n'

html_footer='</body>\n' ..
'</html>'

function lug_sPhoneRequest(lul_request,lul_parameters,lul_outputformat)
	local lul_html = '<div id="toolbar" class="toolbar"><!--logout_btn--></div>' ..
    '<ul id="searches" title="MyHome" selected="true">' ..
	'<li class="group">Scenes</li>\n'
	
	for k,v in pairs(luup.scenes) do
		if( v.room_num==0 and v.hidden==false ) then
			lul_html = lul_html .. '<li class="bg"><a href="data_request?id=lr_sPhone_action&remote=' .. v.remote .. '&page=' .. v.page .. '&room=' .. 0 .. '&device=0&service=urn:micasaverde-com:serviceId:HomeAutomationGateway1&action=RunScene&SceneNum=' .. tostring(k) .. '&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/go.gif" alt="" width="36" height="36" border="0" align="absmiddle" class="icon"/></a> ' .. v.description .. '</li>\n'
		end
	end

    lul_html = lul_html .. '<li class="group">My Home</li>'

	for k,v in pairs(luup.rooms) do
		lul_html = lul_html.. '<li><a class="pic" href="data_request?id=lr_sPhone_room&room=' .. tostring(k) .. '&time=' .. tostring(os.clock()) .. '">' .. v .. '</a></li>\r\n'
	end
	lul_html = lul_html .. '</ul>'

	lul_html = html_header .. lul_html .. html_footer
	return lul_html,"text/html"
end

function lug_sPhoneRequest_action(lul_request,lul_parameters,lul_outputformat)
	local lul_remote = lul_parameters["remote"]
	local lul_page = lul_parameters["page"]
	local lul_room = lul_parameters["room"]
	local lul_device = lul_parameters["device"]
	local lul_action = lul_parameters["action"]
	local lul_service = lul_parameters["service"]
	local html_header_action = ''

	if( lul_remote~=nil and tonumber(lul_remote)>0 ) then
		html_header_action = 
			'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n' ..
			'<html xmlns="http://www.w3.org/1999/xhtml">\n' ..
			'<head>\n' ..
			'	<title>Vera Mobile</title>\n' ..
			'	<meta http-equiv="pragma" content="nocache"/>\n' ..
			'	<meta name="viewport" content="width=device-width; initial-scale=1.0; maximum-scale=1.0;"/> ' ..
			'	<meta http-equiv="refresh" content="0;url=\/port_49451/luvd/PK_Remote_' .. lul_remote .. '_' .. lul_page .. '.html" /> ' ..
			'	<script src="/cmh/js/mobile.js" language="javascript"></script>\n' ..
			'	<link rel="stylesheet" href="http://findvera.com/iphone/iphone_file/css/iui.css" type="text/css" />\n' ..
			'</head>\n' ..
			'<body onLoad="js_prepare_urls();">\n'
	else
		html_header_action = html_header
	end

	if( lul_device==null or lul_action==null or lul_service==null ) then
		luup.log("lug_sPhoneRequest_action: missing arguments")
		return html_header .. '<div> <img src="/cmh/iphone_file/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/>Internal Error: Missing arguments</div>' .. html_footer
	end

	local lul_arguments = {}

	for k,v in pairs(lul_parameters) do
		if( k~="device" and k~="action" and k~="service" and k~="room" and k~="time" ) then
			lul_arguments[k]=v
		end
		
		luup.log("lug_sPhoneRequest_action: " .. tostring(k) .. "=" .. v)
	end

	for k,v in pairs(lul_arguments ) do
		luup.log("lug_sPhoneRequest_action: argument" .. tostring(k) .. "=" .. v)
	end

	lul_resultcode,lul_resultstring,lul_job,lul_returnarguments = luup.call_action(lul_service,lul_action,lul_arguments,tonumber(lul_device))

	luup.log("lug_sPhoneRequest_action: device: " .. tostring(lul_device) .. " action: " .. tostring(lul_action) .. " service: " .. tostring(lul_service)  .. " returned: " .. tostring(lul_resultcode) .. " str " ..tostring(lul_resultstring) .. " job " .. tostring(lul_job))

	if( lul_resultcode~=0 ) then
		return html_header .. '<div><img src="/cmh/iphone_file/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/> Error: ' .. tostring(lul_resultcode) .. ': ' .. tostring(lul_resultstring) .. '<br><a href="data_request?id=lr_sPhone_room&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&time=' .. tostring(os.clock()) .. '">OK - back</a><br></div>' .. html_footer
	end

	if( lul_job==0 ) then
		return html_header_action .. '<div id="toolbar" class="toolbar"> <a href="data_request?id=lr_sPhone_room&room=' .. lul_room .. '&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/images/backButton.gif" border="0"></a> </div>'..
		'<div><img src="/cmh/iphone_file/buttons/ok.gif" alt="" border="0" class="icon" align="absmiddle"/> Command executed OK<br></div>' .. html_footer
	end

	return html_header_action .. '<div id="toolbar" class="toolbar"> <a href="data_request?id=lr_sPhone_room&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/images/backButton.gif" border="0"></a> </div>' ..
		'<div><img src="/cmh/iphone_file/buttons/wait.gif" alt="" border="0" class="icon" align="absmiddle"/> Running command now...<br>' ..
		'<a href="data_request?id=lr_sPhone_job&device=' .. lul_device .. '&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&job=' .. lul_job .. '&time=' .. tostring(os.clock()) .. '">Check the status</a></div>' .. html_footer
end

function lug_sPhoneRequest_camera(lul_device,lul_description,lul_js)
	return '<img src="/cmh/iphone_file/icons/camera.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>' .. lul_description .. '<br>' ..
		'<a href="data_request?id=lr_sPhone_camimg&device=' .. tostring(lul_device) .. '&time=' .. tostring(os.clock()) .. '&js=' .. lul_js .. '"><img src="/cmh/iphone_file/buttons/view.gif" alt="" border="0"/></a> '
end


function lug_sPhoneRequest_job(lul_request,lul_parameters,lul_outputformat)
	local lul_device = lul_parameters["device"]
	local lul_room = lul_parameters["room"]
	local lul_job = lul_parameters["job"]
	
	local lul_job_status,lul_job_text = luup.job.status(lul_job,tonumber(lul_device))
	
	local lul_text = ""

	if( lul_job_status==nill ) then
		lul_text = '<img src="/cmh/iphone_file/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/> No information on command.<br>Command history is only kept for 30 seconds.'
	elseif( lul_job_status==0 or lul_job_status==1 or lul_job_status==5 ) then
		lul_text = '<img src="/cmh/iphone_file/buttons/wait.gif" alt="" border="0" class="icon" align="absmiddle"/> Command is still running...<br>' ..
			'<a href="data_request?id=lr_sPhone_job&device=' .. lul_device .. '&room=' .. lul_room .. '&job=' .. lul_job .. '&time=' .. tostring(os.clock()) .. '">Refresh</a>'
	elseif( lul_job_status==2 or lul_job_status==3 ) then
		lul_text = '<img src="/cmh/iphone_file/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/> Failed to run command'
	elseif( lul_job_status==4 ) then
		lul_text = '<img src="/cmh/iphone_file/buttons/ok.gif" alt="" border="0" class="icon" align="absmiddle"/> Command completed ok'
	else
		lul_text = '<img src="/cmh/iphone_file/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/> Unknown status:' .. tostring(lul_job_status)
	end
		
	return html_header .. 
	'<div id="toolbar" class="toolbar"> <a href="data_request?id=lr_sPhone_room&room=' .. lul_room .. '&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/images/backButton.gif" border="0"></a> </div>' ..
	'<div>' ..
	lul_text ..
	'<div>' ..
	html_footer
end

function lug_sPhoneRequest_light(lul_device,lul_description,lul_js)
	local lul_Status = luup.variable_get("urn:upnp-org:serviceId:SwitchPower1","Status",lul_device)
	local lul_Level = luup.variable_get("urn:upnp-org:serviceId:Dimming1","LoadLevelStatus",lul_device)
	
	local lul_Text = ""
	
	if( lul_Status=="0" ) then
		lul_Text = "Off "
	elseif( lul_Status=="1" ) then
		lul_Text = "On "
	end
	
	if( lul_Level~=nil and lul_Status~="0" ) then
		lul_Text = lul_Text .. lul_Level .. "%"
	end
	
	if( #lul_Text>0 ) then
		lul_Text = "Status: " .. lul_Text .. "<br>"
	end
	
	status_0=''
	status_25=''
	status_50=''
	status_75=''
	status_100=''
	
	if( lul_Level=="0") then
		status_0='_h'
	end	
	if( lul_Level=="25") then
		status_25='_h'
	end	
	if( lul_Level=="50") then
		status_50='_h'
	end	
	if( lul_Level=="75") then
		status_75='_h'
	end	
	if( lul_Level=="100") then
		status_100='_h'
	end	
	
	local lul_html_no_js = '<img src="/cmh/iphone_file/icons/dimmable.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>' .. lul_description .. '<br/>' .. 
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=0&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/off'..status_0..'.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=25&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/25'..status_25..'.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=50&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/50'..status_50..'.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=75&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/75'..status_75..'.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=1&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/on'..status_100..'.gif" alt="" border="0"/></a> '

	local lul_html_js = '<img src="/cmh/iphone_file/icons/dimmable.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>' .. lul_description .. '<br/>' .. 
		'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="action_icon_' .. tostring(lul_device) .. '">' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=0&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/off'..status_0..'.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=25&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/25'..status_25..'.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=50&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/50'..status_50..'.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=75&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/75'..status_75..'.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=1&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/on'..status_100..'.gif" alt="" border="0"/></a> '
	
	if( lul_js=='1' ) then
		return lul_html_js
	else
		return lul_html_no_js
	end			
end

function lug_sPhoneRequest_switch(lul_device,lul_description,lul_js)
	local lul_Status = luup.variable_get("urn:upnp-org:serviceId:SwitchPower1","Status",lul_device)
	
	local lul_Text = ""
	
	if( lul_Status=="0" ) then
		lul_Text = "Off "
	elseif( lul_Status=="1" ) then
		lul_Text = "On "
	end
	
	if( #lul_Text>0 ) then
		lul_Text = "Status: " .. lul_Text .. "<br>"
	end
	status_0=''
	status_100=''
	
	if( lul_Status=="0") then
		status_0='_h'
	end	
	if( lul_Status=="1") then
		status_100='_h'
	end		
	
	local lul_html_no_js = '<img src="/cmh/iphone_file/icons/switch.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />' .. lul_description .. '<br>\n' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=0&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/off' .. status_0 .. '.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=1&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/on' .. status_100 .. '.gif" alt="" border="0"/></a> '

	local lul_html_js = '<img src="/cmh/iphone_file/icons/switch.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_' .. tostring(lul_device) .. '" />' .. lul_description .. '<br>\n' ..
		'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="action_icon_' .. tostring(lul_device) .. '">' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=0&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/off' .. status_0 .. '.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=1&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/on' .. status_100 .. '.gif" alt="" border="0"/></a> '

	if( lul_js=='1' ) then
		return lul_html_js
	else
		return lul_html_no_js
	end	
end

function lug_sPhoneRequest_sensor(lul_device,lul_description,lul_js)
	local lul_Armed = luup.variable_get("urn:micasaverde-com:serviceId:SecuritySensor1","Armed",lul_device)
		lul_Tripped = luup.variable_get("urn:micasaverde-com:serviceId:SecuritySensor1","Tripped",lul_device)
	
	if( lul_Tripped~="1") then
		status_tripped='green'
	else
		status_tripped='red'
	end	
	
	if( lul_Armed~="1") then
		status_arm=''
		status_bypass='_h'
	else
		status_arm='_h'
		status_bypass=''
	end	
	
	lul_html_no_js = '<img src="/cmh/iphone_file/icons/security.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />' .. lul_description .. '<br>\n' ..
		'<a href="data_request?id=lu_variableset&DeviceNum=' .. tostring(lul_device) .. '&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Tripped&time=' .. tostring(os.clock()) .. '"><img src="/cmh/images/' .. status_tripped .. '_circle.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lu_variableset&DeviceNum=' .. tostring(lul_device) .. '&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Armed&Value=1&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/arm' .. status_arm .. '.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lu_variableset&DeviceNum=' .. tostring(lul_device) .. '&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Armed&Value=0&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/bypass' .. status_bypass .. '.gif" alt="" border="0"/></a> '
		

	local lul_html_js = '<img src="/cmh/iphone_file/icons/security.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_' .. tostring(lul_device) .. '" />' .. lul_description .. '<br>\n' ..
		'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="action_icon_' .. tostring(lul_device) .. '">' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lu_variableset&DeviceNum=' .. tostring(lul_device) .. '&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Tripped&Value=1&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/images/' .. status_tripped .. '_circle.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lu_variableset&DeviceNum=' .. tostring(lul_device) .. '&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Armed&Value=1&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/arm' .. status_arm .. '.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lu_variableset&DeviceNum=' .. tostring(lul_device) .. '&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Armed&Value=0&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/bypass' .. status_bypass .. '.gif" alt="" border="0"/></a> '

	if( lul_js=='1' ) then
		return lul_html_js
	else
		return lul_html_no_js
	end			
end

function lug_sPhoneRequest_temp(lul_device,lul_description,lul_js)
	local lul_Temp = luup.variable_get("urn:upnp-org:serviceId:TemperatureSensor1","CurrentTemperature",lul_device)
	
	if( lul_Temp==nil ) then
		lul_Temp='N/A'
	end	

	lul_html_no_js = '<img src="/cmh/iphone_file/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />' .. lul_description .. '<br>\n' ..
		'Temperature: ' .. lul_Temp ..'&deg;<br/>'

	local lul_html_js = '<img src="/cmh/iphone_file/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_' .. tostring(lul_device) .. '" />' .. lul_description .. '<br>\n' ..
		'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="action_icon_' .. tostring(lul_device) .. '">' ..
		'Temperature: ' .. lul_Temp ..'&deg;<br/>'

	if( lul_js=='1' ) then
		return lul_html_js
	else
		return lul_html_no_js
	end			
end

function lug_sPhoneRequest_bright(lul_device,lul_description,lul_js)
	local lul_Level = luup.variable_get("urn:micasaverde-com:serviceId:LightSensor1","CurrentLevel",lul_device)
	
	if( lul_Level==nil ) then
		lul_Level='N/A'
	end	

	lul_html_no_js = '<img src="/cmh/iphone_file/icons/brightness.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />' .. lul_description .. '<br>\n' ..
		'Light level: ' .. lul_Level ..'<br/>'

	local lul_html_js = '<img src="/cmh/iphone_file/icons/brightness.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_' .. tostring(lul_device) .. '" />' .. lul_description .. '<br>\n' ..
		'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="action_icon_' .. tostring(lul_device) .. '">' ..
		'Light level: ' .. lul_Level ..'<br/>'

	if( lul_js=='1' ) then
		return lul_html_js
	else
		return lul_html_no_js
	end			
end

function lug_sPhoneRequest_thermostat(lul_device,lul_description,lul_js)
	local lul_Status = luup.variable_get("urn:upnp-org:serviceId:HVAC_UserOperatingMode1","ModeStatus",lul_device)
	local lul_Heat = luup.variable_get("urn:upnp-org:serviceId:TemperatureSetpoint1_Heat","CurrentSetpoint",lul_device)
	local lul_Cool = luup.variable_get("urn:upnp-org:serviceId:TemperatureSetpoint1_Heat","CurrentSetpoint",lul_device)
	local lul_Temp = luup.variable_get("urn:upnp-org:serviceId:TemperatureSensor1","CurrentTemperature",lul_device)
	local lul_SetPointHeat = luup.variable_get("urn:upnp-org:serviceId:TemperatureSetpoint1_Heat","CurrentSetpoint",lul_device)
	local lul_SetPointCool = luup.variable_get("urn:upnp-org:serviceId:TemperatureSetpoint1_Cool","CurrentSetpoint",lul_device)
	
	local lul_fan_status = luup.variable_get("urn:upnp-org:serviceId:HVAC_FanOperatingMode1","ModeStatus",lul_device)
	
	local lul_Text = ""
	
	status_off=''
	status_cool=''
	status_heat=''
	status_auto=''
	status_fan_on='_h'
	status_fan_auto=''
	
	if( lul_Status=="Off" ) then
		lul_Text = "Off "
		status_off='_h'
	elseif( lul_Status=="HeatOn" ) then
		lul_Text = "Heat "
		status_heat='_h'
	elseif( lul_Status=="CoolOn" ) then
		lul_Text = "Cool "
		status_cool='_h'
	elseif( lul_Status=="AutoChangeOver" ) then
		lul_Text = "Auto "
		status_auto='_h'
	end

	if( lul_fan_status=="Auto" ) then
		status_fan_auto='_h'
		status_fan_on=''		
	end
	
	if( lul_Heat~=nil ) then
		lul_Text = lul_Text .. "Heat: " .. lul_Heat .. " "
	end
	
	if( lul_Cool~=nil ) then
		lul_Text = lul_Text .. "Cool: " .. lul_Cool .. " "
	end

	if( lul_Temp~=nil ) then
		lul_Text = lul_Text .. "Temp: " .. lul_Temp .. " "
	end

	if( #lul_Text>0 ) then
		lul_Text = "Status: " .. lul_Text .. "<br>"
	end
	
	if( lul_SetPointHeat==nil ) then
		lul_SetPointHeat='N/A'
	end	

	if( lul_SetPointCool==nil ) then
		lul_SetPointCool='N/A'
	end	
	
	if( lul_Temp==nil ) then
		lul_Temp='N/A'
	end	
		
	local lul_html_no_js = '<img src="/cmh/iphone_file/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>' .. lul_description .. '<br>\n' .. 
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=Off&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/off' .. status_off ..'.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=CoolOn&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/cool' .. status_cool ..'.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=HeatOn&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/heat' .. status_heat ..'.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=AutoChangeOver&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/auto' .. status_auto ..'.gif" alt="" border="0"/></a> <br/>' ..
		'Fan: <a href="\data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_FanOperatingMode1&action=SetMode&NewMode=Auto&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/auto' .. status_fan_auto ..'.gif" alt="" border="0"/></a>'..
		'<a href="\data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_FanOperatingMode1&action=SetMode&NewMode=ContinuousOn&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/on' .. status_fan_on ..'.gif" alt="" border="0"/></a><br/>'..
		'<table cellpadding="2" cellspacing="0">' ..
		'<form action="\data_request" method="get">' ..		
		'<input type="hidden" name="id" value="lr_sPhone_action">' ..
		'<input type="hidden" name="room" value="' .. luup.devices[tonumber(lul_device)].room_num .. '">' ..
		'<input type="hidden" name="device" value="' .. tostring(lul_device) .. '">' ..
		'<input type="hidden" name="service" value="urn:upnp-org:serviceId:TemperatureSetpoint1_Heat">' ..
		'<input type="hidden" name="action" value="SetCurrentSetpoint">' ..
		'<input type="hidden" name="time" value="' .. tostring(os.clock()) .. '">' ..		
		'	<tr>' ..
		'		<td>Heat: </td>' ..
		'		<td><input type="text" name="NewCurrentSetpoint" value="" size="3"></td>' ..
		'		<td><input type="image" src="/cmh/images/set_deasupra.gif" border="0"></td>' ..
		'	</tr>' ..
		'</form>' ..
		'<form action="\data_request" method="get">' ..		
		'<input type="hidden" name="id" value="lr_sPhone_action">' ..
		'<input type="hidden" name="room" value="' .. luup.devices[tonumber(lul_device)].room_num .. '">' ..
		'<input type="hidden" name="device" value="' .. tostring(lul_device) .. '">' ..
		'<input type="hidden" name="service" value="urn:upnp-org:serviceId:TemperatureSetpoint1_Cool">' ..
		'<input type="hidden" name="action" value="SetCurrentSetpoint">' ..
		'<input type="hidden" name="time" value="' .. tostring(os.clock()) .. '">' ..		
		
		'	<tr>' ..
		'		<td>Cool: </td>' ..
		'		<td><input type="text" name="NewCurrentSetpoint" value="" size="3"></td>' ..
		'		<td><input type="image" src="/cmh/images/set_deasupra.gif" border="0"></td>' ..
		'	</tr>' ..
		'</form>' ..
		'</table>' ..
		'Current temperature: ' .. lul_Temp ..'&deg;<br/>' ..
		'Set point heat: ' .. lul_SetPointHeat ..'&deg;<br/>' ..
		'Set point cool: ' .. lul_SetPointCool ..'&deg;'

	local lul_html_js = '<img src="/cmh/iphone_file/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>' .. lul_description .. '<br>\n' .. 
		'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="action_icon_' .. tostring(lul_device) .. '">' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=Off&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/off' .. status_off ..'.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=CoolOn&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/cool' .. status_cool ..'.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=HeatOn&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/heat' .. status_heat ..'.gif" alt="" border="0"/></a> ' ..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=AutoChangeOver&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/auto' .. status_auto ..'.gif" alt="" border="0"/></a> <br/>' ..
		'Fan: <a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_FanOperatingMode1&action=SetMode&NewMode=Auto&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/auto' .. status_fan_auto ..'.gif" alt="" border="0"/></a>'..
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:HVAC_FanOperatingMode1&action=SetMode&NewMode=ContinuousOn&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/on' .. status_fan_on ..'.gif" alt="" border="0"/></a><br/>'..
		'<table cellpadding="2" cellspacing="0">' ..
		'	<tr>' ..
		'		<td>Heat: </td>' ..
		'		<td><input type="text" name="NewCurrentSetpoint" id="NewCurrentSetpoint_Heat_' .. tostring(lul_device) .. '" value="" size="3"></td>' ..
		'		<td><img src="/cmh/images/set_deasupra.gif" border="0" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:TemperatureSetpoint1_Heat&action=SetCurrentSetpoint&NewCurrentSetpoint=\'+document.getElementById(\'NewCurrentSetpoint_Heat_' .. tostring(lul_device) .. '\').value+\'&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ');" border="0"></td>' ..
		'	</tr>' ..
		
		'	<tr>' ..
		'		<td>Cool: </td>' ..
		'		<td><input type="text" name="NewCurrentSetpoint" id="NewCurrentSetpoint_Cool_' .. tostring(lul_device) .. '" value="" size="3"></td>' ..
		'		<td><img src="/cmh/images/set_deasupra.gif" border="0" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:upnp-org:serviceId:TemperatureSetpoint1_Cool&action=SetCurrentSetpoint&NewCurrentSetpoint=\'+document.getElementById(\'NewCurrentSetpoint_Cool_' .. tostring(lul_device) .. '\').value+\'&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ');" border="0"></td>' ..
		'	</tr>' ..
		'</table>' ..
		'Current temperature: ' .. lul_Temp ..'&deg;<br/>' ..
		'Set point heat: ' .. lul_SetPointHeat ..'&deg;<br/>' ..
		'Set point cool: ' .. lul_SetPointCool ..'&deg;'
	
	if( lul_js=='1' ) then
		return lul_html_js
	else
		return lul_html_no_js
	end			
end

function lug_sPhoneRequest_lock(lul_device,lul_description,lul_js)
	local lul_Status = luup.variable_get("urn:micasaverde-com:serviceId:DoorLock1","Status",lul_device)
	local lul_PinCodes = luup.variable_get("urn:micasaverde-com:serviceId:DoorLock1","PinCodes",lul_device)
	
	local lul_Text = ""
	local lul_existing_codes = ""
	
	status_lock=''
	status_unlock=''
	if( lul_Status=="0" ) then
		lul_Text = "Unlocked "
		status_unlock='_h'
	elseif( lul_Status=="1" ) then
		lul_Text = "Locked "
		status_lock='_h'
	end
	
	if( #lul_Text>0 ) then
		lul_Text = "Status: " .. lul_Text .. "<br>"
	end

	if( lul_PinCodes~=nil and #lul_PinCodes>0 ) then
		lul_existing_codes = '<table cellpadding="2" cellspacing="0">'
		codes = string.split(lul_PinCodes,"\t")
		for index,raw_code in pairs(codes) do
				code_parts = string.split(raw_code,",")
				if(table.getn(code_parts)==5) then
					lul_existing_codes = lul_existing_codes ..
					'<tr>' ..
					'	<td>' .. code_parts[5] .. '</td>' ..
					'	<td><a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:micasaverde-com:serviceId:DoorLock1&action=ClearPin&UserCode='..code_parts[1]..'&time=' .. tostring(os.clock()) .. '"><img src="/cmh/images/remove_deasupra.gif" border="0"></a></td>' ..
					'</tr>'
			end
		end
		lul_existing_codes = lul_existing_codes .. '</table>'
	end

	
	local lul_html_no_js = lul_description .. '<br>' .. 
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetTarget&newTargetValue=0&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/unlock' .. status_unlock.. '.gif" alt="" border="0"/></a> ' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetTarget&newTargetValue=1&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/lock' .. status_lock.. '.gif" alt="" border="0"/></a> ' ..
		'<form action="data_request" method="get">' ..		
		'<input type="hidden" name="id" value="lr_sPhone_action">' ..
		'<input type="hidden" name="room" value="' .. luup.devices[tonumber(lul_device)].room_num .. '">' ..
		'<input type="hidden" name="device" value="' .. tostring(lul_device) .. '">' ..
		'<input type="hidden" name="service" value="urn:micasaverde-com:serviceId:DoorLock1">' ..
		'<input type="hidden" name="action" value="SetPin">' ..
		'<input type="hidden" name="time" value="' .. tostring(os.clock()) .. '">' ..			
		'<table cellpadding="2" cellspacing="0">' ..
		'	<tr>' ..
		'		<td>New code:</td>' ..
		'		<td><input type="text" name="UserCodeName" value="" size="4"></td>' ..
		'	</tr>' ..
		'	<tr>' ..
		'		<td>4 digit code:</td>' ..
		'		<td><input type="text" name="newPin" value="" size="4"></td>' ..
		'	</tr>' ..
		'	<tr>' ..
		'		<td></td>' ..
		'		<td><input type="image" src="/cmh/images/set_deasupra.gif" border="0"></td>' ..
		'	</tr>' ..				
		'</table>' ..
		'</form>' ..
		lul_existing_codes

	local lul_html_js = lul_description .. '<br>' ..
		'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="action_icon_' .. tostring(lul_device) .. '">' ..	
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetTarget&newTargetValue=0&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/unlock' .. status_unlock.. '.gif" alt="" border="0"/></a> ' ..		
		'<a href="javascript:void(0);" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetTarget&newTargetValue=1&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"><img src="/cmh/iphone_file/buttons/lock' .. status_lock.. '.gif" alt="" border="0"/></a> ' ..
		'<form action="data_request" method="get">' ..		
		'<input type="hidden" name="id" value="lr_sPhone_action">' ..
		'<input type="hidden" name="room" value="' .. luup.devices[tonumber(lul_device)].room_num .. '">' ..
		'<input type="hidden" name="device" value="' .. tostring(lul_device) .. '">' ..
		'<input type="hidden" name="service" value="urn:micasaverde-com:serviceId:DoorLock1">' ..
		'<input type="hidden" name="action" value="SetPin">' ..
		'<input type="hidden" name="time" value="' .. tostring(os.clock()) .. '">' ..			
		'<table cellpadding="2" cellspacing="0">' ..
		'	<tr>' ..
		'		<td>New code:</td>' ..
		'		<td><input type="text" name="UserCodeName" id="UserCodeName_' .. tostring(lul_device) .. '" value="" size="4"></td>' ..
		'	</tr>' ..
		'	<tr>' ..
		'		<td>4 digit code:</td>' ..
		'		<td><input type="text" name="newPin" id="newPin_' .. tostring(lul_device) .. '" value="" size="4"></td>' ..
		'	</tr>' ..
		'	<tr>' ..
		'		<td></td>' ..
		'		<td><img src="/cmh/images/set_deasupra.gif" border="0" onClick="set_device_icon(' .. tostring(lul_device) .. ',1);send_command(\'data_request?id=lr_sPhone_action_js&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. tostring(lul_device) .. '&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetPin&UserCodeName=\'+document.getElementById(\'UserCodeName_' .. tostring(lul_device) .. '\').value+\'&newPin=\'+document.getElementById(\'UserCodeName_' .. tostring(lul_device) .. '\').value+\'&time=' .. tostring(os.clock()) .. '\',' .. tostring(lul_device) .. ')"></td>' ..
		'	</tr>' ..				
		'</table>' ..
		'</form>' ..
		lul_existing_codes
		
		
	if( lul_js=='1' ) then
		return lul_html_js
	else
		return lul_html_no_js
	end			
end

function lug_sPhoneRequest_camimg(lul_request,lul_parameters,lul_outputformat)
	local lul_device = lul_parameters["device"]
	local lul_js = lul_parameters["js"]
	if( lul_js==nill or tonumber(lul_js)==0 ) then
		lul_js = 0;
	end
	
	local lul_html_no_js = '<div id="toolbar" class="toolbar"> <a href="data_request?id=lr_sPhone_room&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/images/backButton.gif" border="0"></a> </div>' ..
		'<div align="center">View camera <br/>' ..
		'<img src="data_request?id=cam_image&Device_Num=' .. lul_device .. '&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&time=' .. tostring(os.clock()) .. '"><br>' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. lul_device .. '&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=MoveUp"><img src="/cmh/images/buupdeasupra.gif" border="0"></a>' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. lul_device .. '&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=MoveDown"><img src="/cmh/images/budowndeasupra.gif" border="0"></a>' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. lul_device .. '&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=MoveLeft"><img src="/cmh/images/buldeasupra.gif" border="0"></a>' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. lul_device .. '&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=MoveRight"><img src="/cmh/images/burdeasupra.gif" border="0"></a>' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. lul_device .. '&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=ZoomIn"><img src="/cmh/images/buplusdeasupra.gif" border="0"></a>' ..
		'<a href="data_request?id=lr_sPhone_action&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&device=' .. lul_device .. '&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=ZoomOut"><img src="/cmh/images/buminusdeasupra.gif" border="0"></a>' ..
		'<br><a href="data_request?id=lr_sPhone_camimg&device=' .. lul_device .. '&time=' .. tostring(os.clock()) .. '&js=' .. lul_js ..'">Refresh</a> '
	
	local lul_html_js = '<div id="toolbar" class="toolbar"> <a href="data_request?id=lr_sPhone_room&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/images/backButton.gif" border="0"></a> </div>' ..
		'<div align="center">View camera <br/>' ..
		'<img src="data_request?id=cam_image&Device_Num=' .. lul_device .. '&room=' .. luup.devices[tonumber(lul_device)].room_num .. '&time=' .. tostring(os.clock()) .. '" id="view_' .. tostring(lul_device) .. '"><br>' ..
		'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="action_icon_' .. tostring(lul_device) .. '"><br>' ..
		'<a href="javascript:void(0)" onClick="sp_move_camera(' .. lul_device .. ',\'MoveUp\');"><img src="/cmh/images/buupdeasupra.gif" border="0"></a>' ..
		'<a href="javascript:void(0)" onClick="sp_move_camera(' .. lul_device .. ',\'MoveDown\');"><img src="/cmh/images/budowndeasupra.gif" border="0"></a>' ..
		'<a href="javascript:void(0)" onClick="sp_move_camera(' .. lul_device .. ',\'MoveLeft\');"><img src="/cmh/images/buldeasupra.gif" border="0"></a>' ..
		'<a href="javascript:void(0)" onClick="sp_move_camera(' .. lul_device .. ',\'MoveRight\');"><img src="/cmh/images/burdeasupra.gif" border="0"></a>' ..
		'<a href="javascript:void(0)" onClick="sp_move_camera(' .. lul_device .. ',\'ZoomIn\');"><img src="/cmh/images/buplusdeasupra.gif" border="0"></a>' ..
		'<a href="javascript:void(0)" onClick="sp_move_camera(' .. lul_device .. ',\'ZoomOut\');"><img src="/cmh/images/buminusdeasupra.gif" border="0"></a>' ..
		'<br><a href="data_request?id=lr_sPhone_camimg&device=' .. lul_device .. '&js=' .. lul_js .. '&time=' .. tostring(os.clock()) .. '&js=' .. lul_js ..'">Refresh</a> '

	if( lul_js=='1' ) then
		return html_header .. lul_html_js .. html_footer
	else
		return html_header .. lul_html_no_js .. html_footer
	end			
	
end

function lug_sPhoneRequest_room(lul_request,lul_parameters,lul_outputformat)
	local lul_room = lul_parameters.room
	local lul_js = lul_parameters.js
	if( lul_js==nill or tonumber(lul_js)==0 ) then
		lul_js = 0;
	end
	
	luup.log("lul_js = " .. lul_js)	
	
	if( lul_room==nill or tonumber(lul_room)==0 ) then -- Room 0 means the main menu
		return lug_sPhoneRequest(lul_request,lul_parameters,lul_outputformat)
	end

	local lul_html = '<div id="toolbar" class="toolbar"> <div class="b_left"><a href="data_request?id=lr_sPhone"><img src="/cmh/iphone_file/images/backButton.gif" border="0"></a></div>  <div align="right" class="b_right"><a href="data_request?id=lr_sPhone_room&room=' .. tostring(lul_room) .. '&time=' .. tostring(os.clock()) .. '&js=' .. lul_js .. '"><img src="/cmh/iphone_file/images/refresh.gif" border="0"></a></div></div>' ..
	'<ul title="Room" selected="true">\n'..
	'	<li class="group">Scenes</li>\n'
	
	for k,v in pairs(luup.scenes) do
		if( v.room_num==tonumber(lul_room) and v.hidden==false ) then
			if(lul_js==0) then
				lul_html = lul_html .. '<li class="bg"><a href="data_request?id=lr_sPhone_action&remote=' .. v.remote .. '&page=' .. v.page .. '&room=' .. lul_room .. '&device=0&service=urn:micasaverde-com:serviceId:HomeAutomationGateway1&action=RunScene&SceneNum=' .. tostring(k) .. '&time=' .. tostring(os.clock()) .. '"><img src="/cmh/iphone_file/buttons/go.gif" alt="" width="36" height="36" border="0" align="absmiddle" class="icon"/></a> ' .. v.description .. '</li>\n'
			else
				lul_html = lul_html .. '<li class="bg">'..
				'<img src="/cmh/images/spacer.gif" border="0" width="20" height="20" id="scene_action_icon_' .. tostring(k) .. '" style="vertical-align:middle">' ..				
				'<a href="javascript:void(0)" onClick="set_scene_icon(' .. tostring(k) .. ',1);sp_run_scene(\'data_request?id=lr_sPhone_action_js&remote=' .. v.remote .. '&page=' .. v.page .. '&room=' .. lul_room .. '&device=0&service=urn:micasaverde-com:serviceId:HomeAutomationGateway1&action=RunScene&SceneNum=' .. tostring(k) .. '&time=' .. tostring(os.clock()) .. '\',' .. tostring(k) .. ');">' ..
				'<img src="/cmh/iphone_file/buttons/go.gif" alt="" width="36" height="36" border="0" style="vertical-align:middle" class="icon"/></a> ' .. v.description .. '</li>\n'
			end
		end
	end

	lul_html = lul_html .. '<li class="group">Devices</li>\n'
		
	for k,v in pairs(luup.devices) do
		if( v.room_num==tonumber(lul_room) and v.hidden==false and v.invisible==false ) then
			if( v.category_num==2 ) then -- DEVICE_CATEGORY_DIMMABLE_LIGHT
				lul_html = lul_html .. '<li class="bg">' .. lug_sPhoneRequest_light(k,v.description,lul_js) .. "</li>\n"
			elseif( v.category_num==5 ) then -- DEVICE_CATEGORY_HVAC
				lul_html = lul_html .. '<li class="bg">' .. lug_sPhoneRequest_thermostat(k,v.description,lul_js) .. "</li>\n"
			elseif( v.category_num==7 ) then -- DEVICE_CATEGORY_DOOR_LOCK
				lul_html = lul_html .. '<li class="bg">' .. lug_sPhoneRequest_lock(k,v.description,lul_js) .. "</li>\n"
			elseif( v.category_num==6 ) then -- DEVICE_CATEGORY_CAMERA
				lul_html = lul_html .. '<li class="bg">' .. lug_sPhoneRequest_camera(k,v.description,lul_js) .. "</li>\n"
			elseif( v.category_num==17 ) then -- DEVICE_CATEGORY_TEMPERATURE
				lul_html = lul_html .. '<li class="bg">' .. lug_sPhoneRequest_temp(k,v.description,lul_js) .. "</li>\n"
			elseif( v.category_num==18 ) then -- DEVICE_CATEGORY_LIGHT
				lul_html = lul_html .. '<li class="bg">' .. lug_sPhoneRequest_bright(k,v.description,lul_js) .. "</li>\n"
			elseif( v.category_num==4 or v.category_num==9) then -- DEVICE_CATEGORY_SENSOR, DEVICE_CATEGORY_REMOTE_CONTROL
				lul_html = lul_html .. '<li class="bg">' .. lug_sPhoneRequest_sensor(k,v.description,lul_js) .. "</li>\n"
			elseif( v.category_num~=10 and v.category_num~=13 and v.category_num~=1 and v.category_num~=14) then -- DEVICE_CATEGORY_IR_TX, DEVICE_CATEGORY_SERIAL_PORT, DEVICE_CATEGORY_INTERFACE,DEVICE_CATEGORY_SCENE_CONTROLLER
				lul_html = lul_html .. '<li class="bg">' .. lug_sPhoneRequest_switch(k,v.description,lul_js) .. "</li>\n"
			end
		end
	end

	lul_html = html_header .. lul_html .. html_footer

	return lul_html,"text/html"
end

function string:split(delimiter)
  local result = { }
  local from  = 1
  local delim_from, delim_to = string.find( self, delimiter, from  )
  while delim_from do
    table.insert( result, string.sub( self, from , delim_from-1 ) )
    from  = delim_to + 1
    delim_from, delim_to = string.find( self, delimiter, from  )
  end
  table.insert( result, string.sub( self, from  ) )
  return result
end

function lug_sPhoneRequest_action_js(lul_request,lul_parameters,lul_outputformat)
	local lul_room = lul_parameters["room"]
	local lul_device = lul_parameters["device"]
	local lul_action = lul_parameters["action"]
	local lul_service = lul_parameters["service"]
	if( lul_device==null or lul_action==null or lul_service==null ) then
		luup.log("lug_sPhoneRequest_action: missing arguments")
		return 'ERROR: Missing arguments'
	end

	local lul_arguments = {}

	for k,v in pairs(lul_parameters) do
		if( k~="device" and k~="action" and k~="service" and k~="room" and k~="time" ) then
			lul_arguments[k]=v
		end
		
		luup.log("lug_sPhoneRequest_action: " .. tostring(k) .. "=" .. v)
	end

	for k,v in pairs(lul_arguments ) do
		luup.log("lug_sPhoneRequest_action: argument" .. tostring(k) .. "=" .. v)
	end

	lul_resultcode,lul_resultstring,lul_job,lul_returnarguments = luup.call_action(lul_service,lul_action,lul_arguments,tonumber(lul_device))

	luup.log("lug_sPhoneRequest_action: device: " .. tostring(lul_device) .. " action: " .. tostring(lul_action) .. " service: " .. tostring(lul_service)  .. " returned: " .. tostring(lul_resultcode) .. " str " ..tostring(lul_resultstring) .. " job " .. tostring(lul_job))

	if( lul_resultcode~=0 ) then
		return 'ERROR: ' .. tostring(lul_resultcode) .. ': ' .. tostring(lul_resultstring) 
	end
luup.log("lul_resultcode: " .. lul_resultcode)
luup.log("lul_resultstring: " .. lul_resultstring)
	if( lul_job==0 ) then
		return 'OK'
	end

	return 'Running: ' .. lul_job .. '|' .. lul_device
end

function lug_sPhoneRequest_job_status(lul_request,lul_parameters,lul_outputformat)
	local lul_device = lul_parameters["device"]
	local lul_room = lul_parameters["room"]
	local lul_job = lul_parameters["job"]
	
	local lul_job_status,lul_job_text = luup.job.status(lul_job,tonumber(lul_device))
	
	local lul_text = ""

	if( lul_job_status==nill ) then
		lul_text = 'ERROR: No information on command. Command history is only kept for 30 seconds.'
	elseif( lul_job_status==0 or lul_job_status==1 or lul_job_status==5 ) then
		lul_text = 'Running'
	elseif( lul_job_status==2 or lul_job_status==3 ) then
		lul_text = 'ERROR: Failed to run command'
	elseif( lul_job_status==4 ) then
		lul_text = 'OK'
	else
		lul_text = 'ERROR: Unknown status:' .. tostring(lul_job_status)
	end
		
	return lul_text
end
